"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchResults = exports.NHentaiSort = void 0;
const jsdom_1 = require("jsdom");
var NHentaiSort;
(function (NHentaiSort) {
    NHentaiSort["recent"] = "recent";
    NHentaiSort["today"] = "popular-today";
    NHentaiSort["week"] = "popular-week";
    NHentaiSort["all_time"] = "popular";
})(NHentaiSort = exports.NHentaiSort || (exports.NHentaiSort = {}));
class SearchResults {
    constructor(query, sort = NHentaiSort.recent) {
        this.hentai = [];
        this.total = 0;
        this.pages = 0;
        this.page = 1;
        this.url = `https://nhentai.net/search/?q=${encodeURIComponent(query)}&sort=${sort}&page=`;
    }
    lookup() {
        return __awaiter(this, void 0, void 0, function* () {
            const doc = yield this.getPage();
            this.total = +doc.querySelector('#content h1').textContent.replace(/\D/g, '');
            if (this.total !== 0) {
                const lastNav = doc.querySelector('a.last');
                if (lastNav) {
                    this.pages = +lastNav.getAttribute('href').split('page=')[1];
                }
                else {
                    this.pages = 1;
                }
                this.hentai = yield this.collectHentai(doc);
            }
            return this;
        });
    }
    getPage() {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield jsdom_1.JSDOM.fromURL(this.url + this.page)).window.document;
        });
    }
    collectHentai(doc) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const divs = Array.from(doc.querySelectorAll('div.container div.gallery'));
            const collection = [];
            for (const div of divs) {
                const hentai = {};
                const a = div.querySelector('a.cover');
                hentai.title = (_a = a.querySelector('div.caption')) === null || _a === void 0 ? void 0 : _a.textContent;
                hentai.id = +(a.getAttribute('href') || '').replace(/\D/g, '') || 0;
                hentai.thumbnail = (_b = a.querySelector('img.lazyload')) === null || _b === void 0 ? void 0 : _b.getAttribute('data-src');
                const dataTags = div.getAttribute('data-tags') || '6346';
                hentai.language = dataTags.includes('12227') ? 'english' : dataTags.includes('6346') ? 'japanese' : 'chinese';
                collection.push(hentai);
            }
            return collection;
        });
    }
    next() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.total !== 0 && this.page < this.pages) {
                this.page++;
                const doc = yield this.getPage();
                this.hentai = yield this.collectHentai(doc);
            }
            return this;
        });
    }
    goto(page) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.total !== 0 && page > 0 && page <= this.pages) {
                this.page = page;
                const doc = yield this.getPage();
                this.hentai = yield this.collectHentai(doc);
            }
            return this;
        });
    }
    previous() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.total !== 0 && this.page > 1) {
                this.page--;
                const doc = yield this.getPage();
                this.hentai = yield this.collectHentai(doc);
            }
            return this;
        });
    }
}
exports.SearchResults = SearchResults;
exports.default = SearchResults;
